-----------------------------------------------------------
--- Default configuration
-----------------------------------------------------------
local Defaults = {
    version = 2.0,
    debug = false,
    number = true,
    percent = true,
    count = "up",
}

function dumptable(table)
    local Mesg = ''
    for key, value in pairs(table) do
        Mesg=Mesg..'['..tostring(key)..']' 
        if type(value) == "table" then
            Mesg=Mesg..':'
            print(Mesg)
            dumptable(value)
            Mesg=''
        else
            Mesg=Mesg..' = '..tostring(value)..'('..type(value)..')\n'
        end
    end
--print(Mesg)
end

function XPLeft_Debug( nParam )
    if XPLeftDB.debug then 
        print( "XPLEFT_DEBUG:"..nParam )
    end
end

-----------------------------------------------------------
--- Slash Configuration
-----------------------------------------------------------
local SlashTable = {
    ["debug"] = {
        ["on"] = function(state)
            print "Setting XPLeft Debug on"
            XPLeftDB.debug = true;
        end,
        ["off"] = function(state)
            print "Setting XPLeft Debug off"
            XPLeftDB.debug = false;
        end,
        ["help"] = "Debug commands: on, off"
    },
    ["count"] = {
        ["up"] = function(state)
            print "Setting XPLeft Count Up"
            XPLeftDB.count = "up";
        end,
        ["down"] = function(state)
            print "Setting XPLeft Count Down"
            XPLeftDB.count = "down";
        end,
        ["help"] = "Count commands: up, down"
    },
    ["number"] = function()
        print "Toggling percent"
        if XPLeftDB.number then XPLeftDB.number=false else XPLeftDB.number=true end
    end,
    ["percent"] = function()
        print "Toggling percent"
        if XPLeftDB.percent then XPLeftDB.percent=false else XPLeftDB.percent=true end
    end,
    ["config"] = function()
        print( "Version: ",tostring( XPLeftDB.version ) )
        print( "Debug: ",tostring( XPLeftDB.debug ) )
        print( "Number: ",tostring( XPLeftDB.number ) )
        print( "Percent: ",tostring( XPLeftDB.percent ) )
        print( "Count: ",tostring( XPLeftDB.count ) )
    end,
--    args = {
--        gui = {
--            type = "execute",
--            name = L["GUI Name"],
--            desc = L["GUI Desc"],
--            func = function()
--                InterfaceOptionsFrame_OpenToCategory(XPLeft.optionFrames.main)
--            end,
--        },
    ["help"] = "xpleft commands: debug, count, number, percent, config",
        
}

local function DispatchCommand(message, CmdTable)
    local command,parameter = string.split(" ",message,2)
    local entry = CmdTable[command:lower()]
    local which = type(entry)
    
--    if entry == nil then
--        DispatchCommand("help",CmdTable)
--    else
        if which == "function" then
            entry(parameter)
        elseif which == "table" then
            DispatchCommand(parameter or "", entry)
        elseif which == "string" then
            print(entry)
        else
            DispatchCommand("help",CmdTable)
        end     --if
--    end     --if
end     --function

SlashCmdList["XPLEFT"] = function(message)
    DispatchCommand(message,SlashTable)
end

SLASH_XPLEFT1 = "/xpleft"

-----------------------------------------------------------
--- Entry Points
-----------------------------------------------------------
function XPLeft_OnInitialize(self,event,...)
--    self.optionFrames = {
--        main = dialog:AddToBlizOptions("XPLeft Options", "XPLeft"),
--        profiles = dialog:AddToBlizOptions("XPLeft Profiles", "Profiles", "XPLeft")
--    }

    if XPLeftDB == nil then XPLeftDB = Defaults end
    if event == "VARIABLES_LOADED" then
    dumptable( XPLeftDB )
    if( XPLeftDB.version == nil ) then
        XPLeft_Debug( "Setting database to v2.0 from unversioned." )
        if XPLeftDB.debug ~= nil then Defaults.debug = XPLeftDB.debug end
        if XPLeftDB.number ~= nil then Defaults.number = XPLeftDB.number end
        if XPLeftDB.percent ~= nil then Defaults.percent = XPLeftDB.percent end
        if XPLeftDB.count ~= nil then Defaults.count = XPLeftDB.count end
        XPLeftDB=Defaults
    end

    print( "Initialized" )
    end
end

-----------------------------------------------------------
--- Experience Remaining Hack
-----------------------------------------------------------
function XPLeft_BuildString( Current, Max )
    local text="("
    if( XPLeftDB.number ) then text=text..floor(Max-Current) end
    if( XPLeftDB.number and XPLeftDB.percent) then text=text.."/" end
    if( XPLeftDB.percent ) then 
        if( XPLeftDB.count=="up" ) then
            text=text..floor(100-((Max-Current)*100)/Max).."%"
        else
            text=text..floor(((Max-Current)*100)/Max).."%"
        end
    end
    text=text..")"

    return text
end

function XPLeft_XPChange(self,event,...)
    local CurrentXP = UnitXP( "player" )
    local MaxXP = UnitXPMax( "player" )
    
    if event == "VARIABLES_LOADED" then
--        dumptable( XPLeftDB )
--        XPLeft_OnInitialize()
    else
	TempID = GetShapeshiftFormID()
	local TheText = XPLeft_BuildString( CurrentXP, MaxXP )
        XPLeftFrame.c:SetText(TheText)
    end
end

function XPLeft_RepChange()
    RepName, RepID, RepMin, RepMax, RepCur = GetWatchedFactionInfo()

    local TheText = XPLeft_BuildString( RepCur-RepMin, RepMax-RepMin )
    RepLeftFrame.c:SetText(TheText)
end

function XPLeft_BuildFrame()
    XPLeftFrame=CreateFrame("Frame","XPLeftFrame",MainMenuExpBar);
    XPLeftFrame.c=XPLeftFrame:CreateFontString(nil,"OVERLAY");
    XPLeftFrame.c:SetPoint("BOTTOMRIGHT",MainMenuExpBar,"BOTTOMRIGHT",4,2);
    XPLeftFrame.c:SetJustifyH("RIGHT");
    XPLeftFrame.c:SetFontObject(GameFontNormal);
    XPLeftFrame:SetScript("OnUpdate",XPLeft_XPChange);
    XPLeftFrame:RegisterEvent("VARIABLES_LOADED")
    XPLeftFrame:SetScript("OnEvent",XPLeft_OnInitialize);
    
    RepLeftFrame=CreateFrame("Frame","RepLeftFrame",ReputationWatchBar);
    RepLeftFrame.c=RepLeftFrame:CreateFontString(nil,"OVERLAY");
    RepLeftFrame.c:SetPoint("BOTTOMRIGHT",ReputationWatchBar,"BOTTOMRIGHT",4,2);
    RepLeftFrame.c:SetJustifyH("RIGHT");
    RepLeftFrame.c:SetFontObject(GameFontNormal);
    RepLeftFrame:SetScript("OnUpdate",XPLeft_RepChange);

    print( "Enabled." )
end

XPLeft_BuildFrame()


